class ConvBNActivation(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  out_channels : int
  __annotations__["0"] = __torch__.torch.nn.modules.conv.Conv2d
  __annotations__["1"] = __torch__.torchvision.ops.misc.FrozenBatchNorm2d
  __annotations__["2"] = __torch__.torch.nn.modules.activation.ReLU6
  def forward(self: __torch__.torchvision.models.mobilenetv2.ConvBNActivation,
    input: Tensor) -> Tensor:
    _0 = getattr(self, "0")
    _1 = getattr(self, "1")
    _2 = getattr(self, "2")
    input0 = (_0).forward(input, )
    input1 = (_1).forward(input0, )
    return (_2).forward(input1, )
  def __len__(self: __torch__.torchvision.models.mobilenetv2.ConvBNActivation) -> int:
    return 3
class InvertedResidual(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  stride : int
  use_res_connect : bool
  out_channels : int
  _is_cn : bool
  conv : __torch__.torch.nn.modules.container.Sequential
  def forward(self: __torch__.torchvision.models.mobilenetv2.InvertedResidual,
    x: Tensor) -> Tensor:
    if self.use_res_connect:
      _4 = torch.add(x, (self.conv).forward(x, ), alpha=1)
      _3 = _4
    else:
      _3 = (self.conv).forward(x, )
    return _3
