class FeaturePyramidNetwork(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  inner_blocks : __torch__.torch.nn.modules.container.ModuleList
  layer_blocks : __torch__.torch.nn.modules.container.___torch_mangle_71.ModuleList
  extra_blocks : __torch__.torchvision.ops.feature_pyramid_network.LastLevelMaxPool
  def forward(self: __torch__.torchvision.ops.feature_pyramid_network.FeaturePyramidNetwork,
    x: Dict[str, Tensor]) -> Dict[str, Tensor]:
    _0 = __torch__.torch.nn.functional.___torch_mangle_77.interpolate
    names = torch.list(torch.keys(x))
    x0 = torch.list(torch.values(x))
    last_inner = (self).get_result_from_inner_blocks(x0[-1], -1, )
    results = annotate(List[Tensor], [])
    _1 = (self).get_result_from_layer_blocks(last_inner, -1, )
    _2 = torch.append(results, _1)
    _3 = torch.sub(torch.len(x0), 2)
    last_inner0 = last_inner
    for _4 in range(torch.__range_length(_3, -1, -1)):
      idx = torch.__derive_index(_4, _3, -1)
      inner_lateral = (self).get_result_from_inner_blocks(x0[idx], idx, )
      feat_shape = torch.slice(torch.size(inner_lateral), -2, 9223372036854775807, 1)
      inner_top_down = _0(last_inner0, feat_shape, None, "nearest", None, None, )
      last_inner1 = torch.add(inner_lateral, inner_top_down, alpha=1)
      _5 = (self).get_result_from_layer_blocks(last_inner1, idx, )
      torch.insert(results, 0, _5)
      last_inner0 = last_inner1
    _6 = (self.extra_blocks).forward(results, x0, names, )
    results0, names0, = _6
    _7 = annotate(List[Tuple[str, Tensor]], [])
    _8 = [torch.len(names0), torch.len(results0)]
    for _9 in range(ops.prim.min(_8)):
      k = names0[_9]
      v = results0[_9]
      _10 = torch.append(_7, (k, v))
    return torch.dict(_7)
  def get_result_from_inner_blocks(self: __torch__.torchvision.ops.feature_pyramid_network.FeaturePyramidNetwork,
    x: Tensor,
    idx: int) -> Tensor:
    num_blocks = (self.inner_blocks).__len__()
    if torch.lt(idx, 0):
      idx0 = torch.add(idx, num_blocks)
    else:
      idx0 = idx
    _11 = self.inner_blocks
    _12 = getattr(_11, "0")
    _13 = getattr(_11, "1")
    if torch.eq(0, idx0):
      out = (_12).forward(x, )
    else:
      out = x
    if torch.eq(1, idx0):
      out0 = (_13).forward(x, )
    else:
      out0 = out
    return out0
  def get_result_from_layer_blocks(self: __torch__.torchvision.ops.feature_pyramid_network.FeaturePyramidNetwork,
    x: Tensor,
    idx: int) -> Tensor:
    num_blocks = (self.layer_blocks).__len__()
    if torch.lt(idx, 0):
      idx1 = torch.add(idx, num_blocks)
    else:
      idx1 = idx
    _14 = self.layer_blocks
    _15 = getattr(_14, "0")
    _16 = getattr(_14, "1")
    if torch.eq(0, idx1):
      out = (_15).forward(x, )
    else:
      out = x
    if torch.eq(1, idx1):
      out1 = (_16).forward(x, )
    else:
      out1 = out
    return out1
class LastLevelMaxPool(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  def forward(self: __torch__.torchvision.ops.feature_pyramid_network.LastLevelMaxPool,
    x: List[Tensor],
    y: List[Tensor],
    names: List[str]) -> Tuple[List[Tensor], List[str]]:
    _17 = __torch__.torch.nn.functional._max_pool2d
    _18 = torch.append(names, "pool")
    _19 = _17(x[-1], [1, 1], [2, 2], [0, 0], [1, 1], False, False, )
    _20 = torch.append(x, _19)
    return (x, names)
