class MultiScaleRoIAlign(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : None
  featmap_names : List[str]
  sampling_ratio : int
  output_size : Tuple[int, int]
  scales : Optional[List[float]]
  map_levels : Optional[__torch__.torchvision.ops.poolers.LevelMapper]
  canonical_scale : int
  canonical_level : int
  def forward(self: __torch__.torchvision.ops.poolers.MultiScaleRoIAlign,
    x: Dict[str, Tensor],
    boxes: List[Tensor],
    image_shapes: List[Tuple[int, int]]) -> Tensor:
    _0 = __torch__.torchvision.ops.roi_align.roi_align
    _1 = "This Python function is annotated to be ignored and cannot be run"
    _2 = uninitialized(Tensor)
    _3 = uninitialized(__torch__.torchvision.ops.poolers.LevelMapper)
    _4 = uninitialized(List[float])
    x_filtered = annotate(List[Tensor], [])
    _5 = torch.items(x)
    for _6 in range(torch.len(_5)):
      k, v, = _5[_6]
      _7 = torch.__contains__(self.featmap_names, k)
      if _7:
        _8 = torch.append(x_filtered, v)
      else:
        pass
    num_levels = torch.len(x_filtered)
    rois = (self).convert_to_roi_format(boxes, )
    if torch.__is__(self.scales, None):
      _9 = (self).setup_scales(x_filtered, image_shapes, )
    else:
      pass
    scales = self.scales
    if torch.__isnot__(scales, None):
      scales1 = unchecked_cast(List[float], scales)
      scales0 = scales1
    else:
      ops.prim.RaiseException("AssertionError: ")
      scales0 = _4
    if torch.eq(num_levels, 1):
      _11 = x_filtered[0]
      _12 = self.output_size
      _13 = scales0[0]
      _14 = self.sampling_ratio
      _15, _16, = _12
      _17 = _0(_11, rois, [_15, _16], _13, _14, False, )
      _10 = _17
    else:
      mapper = self.map_levels
      if torch.__isnot__(mapper, None):
        mapper1 = unchecked_cast(__torch__.torchvision.ops.poolers.LevelMapper, mapper)
        mapper0 = mapper1
      else:
        ops.prim.RaiseException("AssertionError: ")
        mapper0 = _3
      levels = (mapper0).__call__(boxes, )
      num_rois = torch.len(rois)
      num_channels = (torch.size(x_filtered[0]))[1]
      dtype = ops.prim.dtype(x_filtered[0])
      device = ops.prim.device(x_filtered[0])
      _18 = self.output_size
      _19 = [num_rois, num_channels]
      _20, _21, = _18
      result = torch.zeros(torch.add(_19, [_20, _21]), dtype=dtype, layout=None, device=device, pin_memory=None)
      _22 = [9223372036854775807, torch.len(x_filtered), torch.len(scales0)]
      for level in range(ops.prim.min(_22)):
        per_level_feature = x_filtered[level]
        scale = scales0[level]
        _23 = torch.where(torch.eq(levels, level))
        idx_in_level = _23[0]
        _24 = annotate(List[Optional[Tensor]], [idx_in_level])
        rois_per_level = torch.index(rois, _24)
        _25 = self.output_size
        _26 = self.sampling_ratio
        _27, _28, = _25
        result_idx_in_level = _0(per_level_feature, rois_per_level, [_27, _28], scale, _26, False, )
        _29 = __torch__.torchvision._is_tracing()
        if _29:
          pass
        else:
          _30 = torch.to(result_idx_in_level, ops.prim.dtype(result), False, False, None)
          _31 = annotate(List[Optional[Tensor]], [idx_in_level])
          _32 = torch.index_put_(result, _31, _30, False)
      _33 = __torch__.torchvision._is_tracing()
      if _33:
        ops.prim.RaiseException(_1)
        result0 = _2
      else:
        result0 = result
      _10 = result0
    return _10
  def convert_to_roi_format(self: __torch__.torchvision.ops.poolers.MultiScaleRoIAlign,
    boxes: List[Tensor]) -> Tensor:
    concat_boxes = torch.cat(boxes, 0)
    device = ops.prim.device(concat_boxes)
    dtype = ops.prim.dtype(concat_boxes)
    _34 = annotate(List[Tensor], [])
    _35 = [9223372036854775807, torch.len(boxes)]
    for i in range(ops.prim.min(_35)):
      b = boxes[i]
      _36 = torch.slice(b, 0, 0, 9223372036854775807, 1)
      _37 = torch.full_like(torch.slice(_36, 1, 0, 1, 1), i, dtype=dtype, layout=0, device=device, pin_memory=None, memory_format=None)
      _38 = torch.append(_34, _37)
    ids = torch.cat(_34, 0)
    return torch.cat([ids, concat_boxes], 1)
  def setup_scales(self: __torch__.torchvision.ops.poolers.MultiScaleRoIAlign,
    features: List[Tensor],
    image_shapes: List[Tuple[int, int]]) -> None:
    _39 = __torch__.torchvision.ops.poolers.initLevelMapper
    _40 = torch.ne(torch.len(image_shapes), 0)
    if _40:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    max_x = 0
    max_y = 0
    for _41 in range(torch.len(image_shapes)):
      shape = image_shapes[_41]
      max_x, max_y = ops.prim.max((shape)[0], max_x), ops.prim.max((shape)[1], max_y)
    scales = annotate(List[float], [])
    for _42 in range(torch.len(features)):
      feat = features[_42]
      _43 = (self).infer_scale(feat, [max_x, max_y], )
      _44 = torch.append(scales, _43)
    _45 = torch.tensor(scales[0], dtype=6, device=None, requires_grad=False)
    lvl_min = torch.neg(torch.item(torch.log2(_45)))
    _46 = torch.tensor(scales[-1], dtype=6, device=None, requires_grad=False)
    lvl_max = torch.neg(torch.item(torch.log2(_46)))
    self.scales = scales
    _47 = _39(int(lvl_min), int(lvl_max), self.canonical_scale, self.canonical_level, 9.9999999999999995e-07, )
    self.map_levels = _47
    return None
  def infer_scale(self: __torch__.torchvision.ops.poolers.MultiScaleRoIAlign,
    feature: Tensor,
    original_size: List[int]) -> float:
    size = torch.slice(torch.size(feature), -2, 9223372036854775807, 1)
    possible_scales = annotate(List[float], [])
    _48 = [torch.len(size), torch.len(original_size)]
    for _49 in range(ops.prim.min(_48)):
      s1 = size[_49]
      s2 = original_size[_49]
      approx_scale = torch.div(float(s1), float(s2))
      _50 = torch.tensor(approx_scale, dtype=None, device=None, requires_grad=False)
      _51 = float(torch.round(torch.log2(_50)))
      scale = torch.pow(2, _51)
      _52 = torch.append(possible_scales, scale)
    _53 = torch.eq(possible_scales[0], possible_scales[1])
    if _53:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    return possible_scales[0]
class LevelMapper:
  k_min : int
  k_max : int
  s0 : int
  lvl0 : int
  eps : float
  def __call__(self: __torch__.torchvision.ops.poolers.LevelMapper,
    boxlists: List[Tensor]) -> Tensor:
    _54 = __torch__.torchvision.ops.boxes.box_area
    _55 = annotate(List[Tensor], [])
    for _56 in range(torch.len(boxlists)):
      boxlist = boxlists[_56]
      _57 = torch.append(_55, _54(boxlist, ))
    s = torch.sqrt(torch.cat(_55, 0))
    _58 = self.lvl0
    _59 = torch.add(torch.log2(torch.div(s, self.s0)), _58, 1)
    _60 = torch.tensor(self.eps, dtype=ops.prim.dtype(s), device=None, requires_grad=False)
    target_lvls = torch.floor(torch.add(_59, _60, alpha=1))
    target_lvls0 = torch.clamp(target_lvls, self.k_min, self.k_max)
    _61 = torch.to(target_lvls0, 4, False, False, None)
    _62 = torch.to(torch.sub(_61, self.k_min, 1), 4, False, False, None)
    return _62
  def __init__(self: __torch__.torchvision.ops.poolers.LevelMapper,
    k_min: int,
    k_max: int,
    canonical_scale: int=224,
    canonical_level: int=4,
    eps: float=9.9999999999999995e-07) -> None:
    self.k_min = k_min
    self.k_max = k_max
    self.s0 = canonical_scale
    self.lvl0 = canonical_level
    self.eps = eps
    return None
def initLevelMapper(k_min: int,
    k_max: int,
    canonical_scale: int=224,
    canonical_level: int=4,
    eps: float=9.9999999999999995e-07) -> __torch__.torchvision.ops.poolers.LevelMapper:
  _63 = __torch__.torchvision.ops.poolers.LevelMapper.__new__(__torch__.torchvision.ops.poolers.LevelMapper)
  _64 = (_63).__init__(k_min, k_max, canonical_scale, canonical_level, eps, )
  return _63
