class DetectionModel(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  model : __torch__.torchvision.models.detection.faster_rcnn.FasterRCNN
  def forward(self: __torch__.DetectionModel,
    x: Tensor,
    ids: Optional[Tensor]=None,
    bboxes: Optional[Tensor]=None,
    labels: Optional[Tensor]=None) -> Tuple[Tensor, List[Dict[str, Tensor]]]:
    _0 = uninitialized(Tensor)
    l_x = annotate(List[Tensor], [])
    for i in range((torch.size(x))[0]):
      _1 = torch.append(l_x, torch.select(x, 0, i))
    if self.training:
      if torch.__isnot__(ids, None):
        ids0 = unchecked_cast(Tensor, ids)
      else:
        ops.prim.RaiseException("AssertionError: ")
        ids0 = _0
      if torch.__isnot__(bboxes, None):
        bboxes0 = unchecked_cast(Tensor, bboxes)
      else:
        ops.prim.RaiseException("AssertionError: ")
        bboxes0 = _0
      if torch.__isnot__(labels, None):
        labels0 = unchecked_cast(Tensor, labels)
      else:
        ops.prim.RaiseException("AssertionError: ")
        labels0 = _0
      l_targs = annotate(List[Dict[str, Tensor]], [])
      stop = 0
      for i0 in range((torch.size(x))[0]):
        _2 = torch.lt(stop, (torch.size(ids0))[0])
        if _2:
          _4 = torch.eq(torch.select(ids0, 0, stop), i0)
          _3 = bool(_4)
        else:
          _3 = False
        stop0 = stop
        _5 = _3
        while _5:
          stop1 = torch.add(stop0, 1)
          _6 = torch.lt(stop1, (torch.size(ids0))[0])
          if _6:
            _8 = torch.select(ids0, 0, stop1)
            _7 = bool(torch.eq(_8, i0))
          else:
            _7 = False
          _5, stop0 = _7, stop1
        _9 = torch.slice(bboxes0, 0, stop, stop0, 1)
        _10 = torch.slice(labels0, 0, stop, stop0, 1)
        targ = {"boxes": _9, "labels": _10}
        _11 = torch.append(l_targs, targ)
        stop = stop0
      _12 = (self.model).forward(l_x, l_targs, )
      losses, predictions0, = _12
      losses0 = annotate(List[Tensor], [])
      _13 = torch.values(losses)
      for _14 in range(torch.len(_13)):
        l = _13[_14]
        _15 = torch.append(losses0, l)
      _16 = ops.prim.device(x)
      _17 = ops.prim.dtype(x)
      loss0 = torch.zeros([1], dtype=_17, layout=None, device=_16, pin_memory=None)
      loss1 = loss0
      for i1 in range(torch.len(losses0)):
        loss2 = torch.add_(loss1, losses0[i1], alpha=1)
        loss1 = loss2
      loss, predictions = loss1, predictions0
    else:
      losses1, predictions1, = (self.model).forward(l_x, None, )
      _18 = ops.prim.device(x)
      _19 = ops.prim.dtype(x)
      loss3 = torch.zeros([1], dtype=_19, layout=None, device=_18, pin_memory=None)
      loss, predictions = loss3, predictions1
    return (loss, predictions)
