class BackboneWithFPN(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  out_channels : int
  body : __torch__.torchvision.models._utils.IntermediateLayerGetter
  fpn : __torch__.torchvision.ops.feature_pyramid_network.FeaturePyramidNetwork
  def forward(self: __torch__.torchvision.models.detection.backbone_utils.BackboneWithFPN,
    x: Tensor) -> Dict[str, Tensor]:
    x0 = (self.body).forward(x, )
    return (self.fpn).forward(x0, )
